#ifndef _KURL_H_
#define _KURL_H_

#include <Q3Url>
#include <Q3ValueList>
#include <QTemporaryFile>

namespace Piklab
{

//-----------------------------------------------------------------------------
class KURL : public Q3Url
{
public:
  KURL() {}
  KURL(const QString &s) : Q3Url(s) {}
  void cleanPath() {}
  bool isEmpty() const { return toString(false, false).isEmpty(); }
  QString fileName(bool b) const { Q_UNUSED(b); Q_ASSERT(!b); return Q3Url::fileName(); }
  QString htmlURL() const { return toString(); }
  QString url() { return encodedPathAndQuery(); }
  QString prettyURL() const { return toString(false, false); }
  static KURL fromPathOrURL(const QString &s) { return KURL(s); }
  bool operator <(const KURL &url) const { return path()<url.path(); }
  bool operator ==(const KURL &url) const { return path()==url.path(); }
  bool operator !=(const KURL &url) const { return path()!=url.path(); }

  typedef Q3ValueList<KURL> List;
};

//-----------------------------------------------------------------------------
class KTempFile
{
public:
  KTempFile(QString filePrefix = QString::null,
	    QString fileExtension = QString::null);
  bool close() { _file.close(); return true; }
  bool setAutoDelete(bool autoDelete) { _file.setAutoRemove(autoDelete); }
  int status() const { return _file.error() == QFile::NoError ? 0 : 1; }
  QString name() const { return _file.fileName(); }
  const QFile *file() const { return &_file; }
  QFile *file() { return &_file; }

private:
  QTemporaryFile _file;
};

} // namespace Piklab

#endif
